package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.util.DamageSourceExtension;
import java.util.function.Function;
import net.minecraft.tags.DamageTypeTags;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.event.entity.living.LivingHurtEvent;

public class MagicalArrowAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.MagicalArrowAffix> CODEC;
  
  protected LootRarity minRarity;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)LootRarity.CODEC.fieldOf("min_rarity").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.MagicalArrowAffix::new));
  }
  
  public MagicalArrowAffix(LootRarity minRarity) {
    super(AffixType.ABILITY);
    this.minRarity = minRarity;
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (cat.isRanged() && rarity.isAtLeast(this.minRarity));
  }
  
  public void onHurt(LivingHurtEvent e) {
    Entity entity = e.getSource().m_7640_();
    if (entity instanceof AbstractArrow) {
      AbstractArrow arrow = (AbstractArrow)entity;
      if (AffixHelper.getAffixes(arrow).containsKey(Apoth.Affixes.MAGICAL))
        ((DamageSourceExtension)e.getSource()).addTag(DamageTypeTags.f_268490_); 
    } 
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
}
